<?php
namespace FORM4\Form4Teaser\View;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 form4 GmbH & Co. KG <typo3@form4.de>
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
use \TYPO3\CMS\Core\Utility\GeneralUtility;
use \FORM4\Form4Teaser\Utility\ConfigurationUtility;
use \FORM4\Form4Teaser\Exception;

/**
 * A teaser template view - resolves paths according to the registred layouts.
 *
 * @author Thomas Grothaus <thomas.grothaus@form4.de>
 * @author Stephan Jorek <stephan.jorek@form4.de>
 *
 * @package TYPO3
 * @subpackage form4_teaser
 *
 */
class TeaserView extends \TYPO3\CMS\Fluid\View\TemplateView {

	/**
	 *
	 * @var string
	 */
	protected $teaserTemplateIdentifier;

	/**
	 *
	 * @var string
	 */
	protected $teaserLayoutIdentifier;

	/**
	 * Just calling parent::__construct to keep inheritance chain intact …
	 */
	public function __construct() {
		parent::__construct();
	}

	/**
	 * Just calling parent::initializeView to keep inheritance chain intact …
	 * @return void
	 */
	public function initializeView() {
		parent::initializeView();
	}

	/**
	 * inject the settings in the view
	 * @param array $settings
	 *
	 */
	public function injectSettings($settings) {
// 		if ($settings['template']) {
// 			$this->teaserTemplateIdentifier = $settings['template'];
// 		}
		if ($settings['layout']) {
			$this->teaserLayoutIdentifier = $settings['layout'];
		}
	}

// 	/**
// 	 * Resolve the template path and filename for the given action. If $actionName
// 	 * is NULL, looks into the current request.
// 	 *
// 	 * @param string $actionName Name of the action. If NULL, will be taken from request.
// 	 * @return string Full path to template
// 	 * @throws \TYPO3\CMS\Fluid\View\Exception\InvalidTemplateResourceException
// 	 */
// 	protected function getTemplatePathAndFilename($actionName = NULL) {
// 		if (isset($this->teaserTemplateIdentifier) && $this->teaserTemplateIdentifier) {
// 			$filepath = ConfigurationUtility::getFluidTemplateFilePath($this->teaserTemplateIdentifier);
// 			if ($filepath === FALSE) {
// 				throw new Exception(sprintf('Could not resolve templatePathAndFilename for layout "%s"', $this->teaserTemplateIdentifier));
// 			}
// 			return $filepath;
// 		}
// 		return parent::getTemplatePathAndFilename($actionName);
// 	}

	/**
	 * @param string $layoutName Name of the layout to use. If none given, use "Default
	 * @return string Path and filename of layout files
	 */
	protected function getLayoutPathAndFilename($layoutName = 'Default') {
		$layout = ConfigurationUtility::getLayout($layoutName);
		$templateName = $layout['template'];
		
		if (substr($templateName, 0, 4) === 'EXT:') {
			$template = GeneralUtility::getFileAbsFileName($templateName);
		} else {
			$template = parent::getLayoutPathAndFilename($templateName);
		}
		
		return $template;
	}
}

?>